commit:     c536aa491eb010d0278d22cc75725eab1dd627da
Author:     Andreas K. Hüttel <dilfridge <AT> gentoo <DOT> org>
AuthorDate: Sun Sep  6 10:39:30 2020 +0000
Commit:     Andreas K. Hüttel <dilfridge <AT> gentoo <DOT> org>
CommitDate: Sun Sep  6 10:39:30 2020 +0000
URL:        https://gitweb.gentoo.org/proj/riscv.git/commit/?id=c536aa49

dev-libs/{gmp,mpc,mpfr}: Copy from main tree to get additional abis

Signed-off-by: Andreas K. Hüttel <dilfridge <AT> gentoo.org>

 dev-libs/gmp/Manifest                              |   2 +
 .../gmp/files/gmp-6.1.0-noexecstack-detect.patch   |  23 +++++
 dev-libs/gmp/files/gmp-6.1.2-gcc-apple-4.0.1.patch |  21 +++++
 dev-libs/gmp/gmp-6.2.0-r1.ebuild                   | 105 +++++++++++++++++++++
 dev-libs/gmp/metadata.xml                          |  15 +++
 dev-libs/mpc/Manifest                              |   2 +
 dev-libs/mpc/metadata.xml                          |   8 ++
 dev-libs/mpc/mpc-1.1.0-r1.ebuild                   |  28 ++++++
 dev-libs/mpc/mpc-1.2.0.ebuild                      |  28 ++++++
 dev-libs/mpfr/Manifest                             |   2 +
 dev-libs/mpfr/metadata.xml                         |   8 ++
 dev-libs/mpfr/mpfr-4.0.2.ebuild                    |  58 ++++++++++++
 dev-libs/mpfr/mpfr-4.1.0.ebuild                    |  32 +++++++
 13 files changed, 332 insertions(+)

diff --git a/dev-libs/gmp/Manifest b/dev-libs/gmp/Manifest
new file mode 100644
index 0000000..eb46a81
--- /dev/null
+++ b/dev-libs/gmp/Manifest
@@ -0,0 +1,2 @@
+DIST gmp-6.2.0.tar.xz 2012444 BLAKE2B 
928141cf7b0b70f78b66e7bc52aecd39a5fc30e8865b6de6effb5b061ade05a5a51b4680ef2f36ea0d682b319d54ceb1c6c8ef93bde6c2eef2e8b826a34602c3
 SHA512 
a066f0456f0314a1359f553c49fc2587e484ff8ac390ff88537266a146ea373f97a1c0ba24608bf6756f4eab11c9056f103c8deb99e5b57741b4f7f0ec44b90c
+DIST gmp-man-6.2.0.pdf 828998 BLAKE2B 
0bf56bf0a6f1aac0e1fb9a5a37552f846a2d4a01bfd3f5b5c531d42a9afc48c19552e08971785805f59e3f2a5fd89e3f986f841dca2e340813596cfd76574e61
 SHA512 
25d129efedd329cd2d4535557c6912191f587bfd8ef028618b4ca6199ec7bf7a9ae862e7f5e5b5448c86888452a39fc7bf95cf9c18311858dd1aa9ae1c716239

diff --git a/dev-libs/gmp/files/gmp-6.1.0-noexecstack-detect.patch 
b/dev-libs/gmp/files/gmp-6.1.0-noexecstack-detect.patch
new file mode 100644
index 0000000..558ba60
--- /dev/null
+++ b/dev-libs/gmp/files/gmp-6.1.0-noexecstack-detect.patch
@@ -0,0 +1,23 @@
+gmp's -Wa,--noexecstack check is based on glibc's, so backport a change
+that went into it there:
+https://sourceware.org/git/?p=glibc.git;a=commitdiff;h=215a87451d1fd623fd2699fa57f16f8ab6f6a2f3
+https://sourceware.org/bugzilla/show_bug.cgi?id=6428
+
+this is to workaround broken clang assembler that fails w/CFLAGS=-g:
+http://crbug.com/585930
+https://llvm.org/bugs/show_bug.cgi?id=11740
+
+patch has been sent upstream too:
+https://gmplib.org/list-archives/gmp-bugs/2016-February/003916.html
+
+--- a/configure
++++ b/configure
+@@ -11339,7 +11339,7 @@ EOF
+   $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
+   test $ac_status = 0; }; } \
+      && grep .note.GNU-stack conftest.s >/dev/null \
+-     && { ac_try='${CC} $CFLAGS $CPPFLAGS -Wa,--noexecstack
++     && { ac_try='${CC} $ASMFLAGS -Wa,--noexecstack
+                        -c -o conftest.o conftest.s >/dev/null'
+   { { eval echo "\"\$as_me\":${as_lineno-$LINENO}: \"$ac_try\""; } >&5
+   (eval $ac_try) 2>&5

diff --git a/dev-libs/gmp/files/gmp-6.1.2-gcc-apple-4.0.1.patch 
b/dev-libs/gmp/files/gmp-6.1.2-gcc-apple-4.0.1.patch
new file mode 100644
index 0000000..8960464
--- /dev/null
+++ b/dev-libs/gmp/files/gmp-6.1.2-gcc-apple-4.0.1.patch
@@ -0,0 +1,21 @@
+--- gmp-6.0.0/gmp-h.in.orig    2015-01-16 22:25:51.000000000 +0100
++++ gmp-6.0.0/gmp-h.in 2015-01-16 22:26:40.000000000 +0100
+@@ -360,14 +360,14 @@
+     GCC 4.3 and above with -std=c99 or -std=gnu99 implements ISO C99
+     inline semantics, unless -fgnu89-inline is used.  */
+ #ifdef __GNUC__
+-#if (defined __GNUC_STDC_INLINE__) || (__GNUC__ == 4 && __GNUC_MINOR__ == 2) \
+-  || (defined __GNUC_GNU_INLINE__ && defined __cplusplus)
++#if __GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 2)
+ #define __GMP_EXTERN_INLINE extern __inline__ __attribute__ ((__gnu_inline__))
+-#else
++#define __GMP_INLINE_PROTOTYPES  1
++#elif !(defined __APPLE__ && defined __MACH__ && __APPLE_CC__ >= 5465 && 
__STDC_VERSION__ >= 199901L)
+ #define __GMP_EXTERN_INLINE      extern __inline__
+-#endif
+ #define __GMP_INLINE_PROTOTYPES  1
+ #endif
++#endif
+ 
+ /* DEC C (eg. version 5.9) supports "static __inline foo()", even in -std1
+    strict ANSI mode.  Inlining is done even when not optimizing (ie. -O0

diff --git a/dev-libs/gmp/gmp-6.2.0-r1.ebuild b/dev-libs/gmp/gmp-6.2.0-r1.ebuild
new file mode 100644
index 0000000..4417fec
--- /dev/null
+++ b/dev-libs/gmp/gmp-6.2.0-r1.ebuild
@@ -0,0 +1,105 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit flag-o-matic eutils libtool multilib-minimal toolchain-funcs
+
+MY_PV=${PV/_p*}
+MY_PV=${MY_PV/_/-}
+MY_P=${PN}-${MY_PV}
+PLEVEL=${PV/*p}
+DESCRIPTION="Library for arbitrary-precision arithmetic on different type of 
numbers"
+HOMEPAGE="https://gmplib.org/";
+SRC_URI="ftp://ftp.gmplib.org/pub/${MY_P}/${MY_P}.tar.xz
+       mirror://gnu/${PN}/${MY_P}.tar.xz
+       doc? ( https://gmplib.org/${PN}-man-${MY_PV}.pdf )"
+
+LICENSE="|| ( LGPL-3+ GPL-2+ )"
+# The subslot reflects the C & C++ SONAMEs.
+SLOT="0/10.4"
+KEYWORDS="~alpha amd64 arm arm64 hppa ~ia64 ~m68k ~mips ppc ppc64 ~riscv s390 
sparc x86 ~ppc-aix ~x64-cygwin ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos 
~x86-macos ~m68k-mint ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+IUSE="+asm doc +cxx pic static-libs"
+
+BDEPEND="sys-devel/m4
+       app-arch/xz-utils"
+
+S=${WORKDIR}/${MY_P%a}
+
+DOCS=( AUTHORS ChangeLog NEWS README doc/configuration doc/isa_abi_headache )
+HTML_DOCS=( doc )
+MULTILIB_WRAPPED_HEADERS=( /usr/include/gmp.h )
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-6.1.0-noexecstack-detect.patch
+)
+
+src_prepare() {
+       default
+
+       # note: we cannot run autotools here as gcc depends on this package
+       elibtoolize
+
+       # https://bugs.gentoo.org/536894
+       if [[ ${CHOST} == *-darwin* ]] ; then
+               eapply "${FILESDIR}"/${PN}-6.1.2-gcc-apple-4.0.1.patch
+       fi
+
+       # GMP uses the "ABI" env var during configure as does Gentoo (econf).
+       # So, to avoid patching the source constantly, wrap things up.
+       mv configure configure.wrapped || die
+       cat <<-\EOF > configure
+       #!/usr/bin/env sh
+       exec env ABI="${GMPABI}" "$0.wrapped" "$@"
+       EOF
+       # Patches to original configure might have lost the +x bit.
+       chmod a+rx configure{,.wrapped} || die
+}
+
+multilib_src_configure() {
+       # Because of our 32-bit userland, 1.0 is the only HPPA ABI that works
+       # https://gmplib.org/manual/ABI-and-ISA.html#ABI-and-ISA (bug #344613)
+       if [[ ${CHOST} == hppa2.0-* ]] ; then
+               GMPABI="1.0"
+       fi
+
+       # ABI mappings (needs all architectures supported)
+       case ${ABI} in
+               32|x86)       GMPABI=32;;
+               64|amd64|n64) GMPABI=64;;
+               [onx]32)      GMPABI=${ABI};;
+       esac
+       export GMPABI
+
+       #367719
+       if [[ ${CHOST} == *-mint* ]]; then
+               filter-flags -O?
+       fi
+
+       # --with-pic forces static libraries to be built as PIC
+       # and without TEXTRELs. musl does not support TEXTRELs: bug #707332
+       tc-export CC
+       ECONF_SOURCE="${S}" econf \
+               CC_FOR_BUILD="$(tc-getBUILD_CC)" \
+               --localstatedir="${EPREFIX}"/var/state/gmp \
+               --enable-shared \
+               $(use_enable asm assembly) \
+               $(use_enable cxx) \
+               $(use pic && echo --with-pic) \
+               $(use_enable static-libs static)
+}
+
+multilib_src_install() {
+       emake DESTDIR="${D}" install
+
+       # should be a standalone lib
+       rm -f "${ED}"/usr/$(get_libdir)/libgmp.la
+       # this requires libgmp
+       local la="${ED}/usr/$(get_libdir)/libgmpxx.la"
+       use static-libs || rm -f "${la}"
+}
+
+multilib_src_install_all() {
+       einstalldocs
+       use doc && cp "${DISTDIR}"/gmp-man-${MY_PV}.pdf 
"${ED}"/usr/share/doc/${PF}/
+}

diff --git a/dev-libs/gmp/metadata.xml b/dev-libs/gmp/metadata.xml
new file mode 100644
index 0000000..2b4236a
--- /dev/null
+++ b/dev-libs/gmp/metadata.xml
@@ -0,0 +1,15 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd";>
+<pkgmetadata>
+<maintainer type="project">
+       <email>[email protected]</email>
+       <name>Gentoo Toolchain Project</name>
+</maintainer>
+<use>
+       <flag name="asm">Enable use of hand optimized assembly routines (faster 
execution)</flag>
+       <flag name="pic">Force static libraries to be built as PIC to avoid 
TEXTRELs.</flag>
+</use>
+<upstream>
+       <remote-id type="cpe">cpe:/a:gmplib:gmp</remote-id>
+</upstream>
+</pkgmetadata>

diff --git a/dev-libs/mpc/Manifest b/dev-libs/mpc/Manifest
new file mode 100644
index 0000000..070ae4a
--- /dev/null
+++ b/dev-libs/mpc/Manifest
@@ -0,0 +1,2 @@
+DIST mpc-1.1.0.tar.gz 701263 BLAKE2B 
afd9fefe687b7cd3c3a483e183f366348e34f58f5d713e2f6b38da16e2e382248b446d9da01ea89fe7202b795b08929b7c42c89c2c1e9a57482faf01ee697beb
 SHA512 
72d657958b07c7812dc9c7cbae093118ce0e454c68a585bfb0e2fa559f1bf7c5f49b93906f580ab3f1073e5b595d23c6494d4d76b765d16dde857a18dd239628
+DIST mpc-1.2.0.tar.gz 840711 BLAKE2B 
3609d299623a722ca90d4b04ff64becaaa399a5fa40fbc43a1d027692d8fbe6f4ebd24a3c8ea963963977952d130cd3993887da7b0b0c1613a27a24dd37e5831
 SHA512 
84fa3338f51d369111456a63ad040256a1beb70699e21e2a932c779aa1c3bd08b201412c1659ecbb58403ea0548faacc35996d94f88f0639549269b7563c61b7

diff --git a/dev-libs/mpc/metadata.xml b/dev-libs/mpc/metadata.xml
new file mode 100644
index 0000000..67bd6a9
--- /dev/null
+++ b/dev-libs/mpc/metadata.xml
@@ -0,0 +1,8 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd";>
+<pkgmetadata>
+       <maintainer type="project">
+               <email>[email protected]</email>
+               <name>Gentoo Toolchain Project</name>
+       </maintainer>
+</pkgmetadata>

diff --git a/dev-libs/mpc/mpc-1.1.0-r1.ebuild b/dev-libs/mpc/mpc-1.1.0-r1.ebuild
new file mode 100644
index 0000000..ccf53fd
--- /dev/null
+++ b/dev-libs/mpc/mpc-1.1.0-r1.ebuild
@@ -0,0 +1,28 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+inherit multilib-minimal
+
+DESCRIPTION="A library for multiprecision complex arithmetic with exact 
rounding"
+HOMEPAGE="http://mpc.multiprecision.org/";
+SRC_URI="mirror://gnu/${PN}/${P}.tar.gz"
+
+LICENSE="LGPL-2.1"
+SLOT="0/3"
+KEYWORDS="~alpha amd64 arm arm64 hppa ~ia64 ~m68k ~mips ppc ppc64 ~riscv s390 
sparc x86 ~ppc-aix ~x64-cygwin ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos 
~x86-macos ~m68k-mint ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+IUSE="static-libs"
+
+DEPEND=">=dev-libs/gmp-5.0.0:0=[${MULTILIB_USEDEP},static-libs?]
+       >=dev-libs/mpfr-3.0.0:0=[${MULTILIB_USEDEP},static-libs?]"
+RDEPEND="${DEPEND}"
+
+multilib_src_configure() {
+       ECONF_SOURCE=${S} econf $(use_enable static-libs static)
+}
+
+multilib_src_install_all() {
+       einstalldocs
+       find "${D}" -name '*.la' -delete || die
+}

diff --git a/dev-libs/mpc/mpc-1.2.0.ebuild b/dev-libs/mpc/mpc-1.2.0.ebuild
new file mode 100644
index 0000000..1bdc785
--- /dev/null
+++ b/dev-libs/mpc/mpc-1.2.0.ebuild
@@ -0,0 +1,28 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit multilib-minimal
+
+DESCRIPTION="A library for multiprecision complex arithmetic with exact 
rounding"
+HOMEPAGE="http://mpc.multiprecision.org/";
+SRC_URI="mirror://gnu/${PN}/${P}.tar.gz"
+
+LICENSE="LGPL-2.1"
+SLOT="0/3" # libmpc.so.3
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~riscv 
~s390 ~sparc ~x86 ~ppc-aix ~x64-cygwin ~amd64-linux ~x86-linux ~ppc-macos 
~x64-macos ~x86-macos ~m68k-mint ~sparc-solaris ~sparc64-solaris ~x64-solaris 
~x86-solaris"
+IUSE="static-libs"
+
+DEPEND=">=dev-libs/gmp-5.0.0:0=[${MULTILIB_USEDEP},static-libs?]
+       >=dev-libs/mpfr-4.1.0:0=[${MULTILIB_USEDEP},static-libs?]"
+RDEPEND="${DEPEND}"
+
+multilib_src_configure() {
+       ECONF_SOURCE=${S} econf $(use_enable static-libs static)
+}
+
+multilib_src_install_all() {
+       einstalldocs
+       find "${D}" -name '*.la' -delete || die
+}

diff --git a/dev-libs/mpfr/Manifest b/dev-libs/mpfr/Manifest
new file mode 100644
index 0000000..de6556d
--- /dev/null
+++ b/dev-libs/mpfr/Manifest
@@ -0,0 +1,2 @@
+DIST mpfr-4.0.2.tar.xz 1441996 BLAKE2B 
4c1a15208c2dc3dcc1424974de506198e9cc479c70255149876c7f541133499ada5c89f07393b120b7079e6bbaf8ea03e5e496e1350b295e687392a6e0341c1c
 SHA512 
d583555d08863bf36c89b289ae26bae353d9a31f08ee3894520992d2c26e5683c4c9c193d7ad139632f71c0a476d85ea76182702a98bf08dde7b6f65a54f8b88
+DIST mpfr-4.1.0.tar.xz 1525476 BLAKE2B 
41d1be0c4b557760f12a4525ad3a84b6e2cd6f0927c935fcfba577ac0490e582d1ae4b581dce58e21e705cf9d7c88373054d7fb7a94bb32c69b339f99a25dc68
 SHA512 
1bd1c349741a6529dfa53af4f0da8d49254b164ece8a46928cdb13a99460285622d57fe6f68cef19c6727b3f9daa25ddb3d7d65c201c8f387e421c7f7bee6273

diff --git a/dev-libs/mpfr/metadata.xml b/dev-libs/mpfr/metadata.xml
new file mode 100644
index 0000000..e396f37
--- /dev/null
+++ b/dev-libs/mpfr/metadata.xml
@@ -0,0 +1,8 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd";>
+<pkgmetadata>
+<maintainer type="project">
+       <email>[email protected]</email>
+       <name>Gentoo Toolchain Project</name>
+</maintainer>
+</pkgmetadata>

diff --git a/dev-libs/mpfr/mpfr-4.0.2.ebuild b/dev-libs/mpfr/mpfr-4.0.2.ebuild
new file mode 100644
index 0000000..b5731b6
--- /dev/null
+++ b/dev-libs/mpfr/mpfr-4.0.2.ebuild
@@ -0,0 +1,58 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+# NOTE: we cannot depend on autotools here starting with gcc-4.3.x
+inherit libtool multilib-minimal preserve-libs
+
+MY_PV=${PV/_p*}
+MY_P=${PN}-${MY_PV}
+PLEVEL=${PV/*p}
+DESCRIPTION="library for multiple-precision floating-point computations with 
exact rounding"
+HOMEPAGE="https://www.mpfr.org/";
+SRC_URI="https://www.mpfr.org/mpfr-${MY_PV}/${MY_P}.tar.xz";
+
+LICENSE="LGPL-2.1"
+SLOT="0/6" # libmpfr.so version
+KEYWORDS="~alpha amd64 arm arm64 hppa ~ia64 ~m68k ~mips ppc ppc64 ~riscv s390 
sparc x86 ~ppc-aix ~x64-cygwin ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos 
~x86-macos ~m68k-mint ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+IUSE="static-libs"
+
+RDEPEND=">=dev-libs/gmp-5.0.0[${MULTILIB_USEDEP},static-libs?]"
+DEPEND="${RDEPEND}"
+
+S=${WORKDIR}/${MY_P}
+
+HTML_DOCS=( doc/FAQ.html )
+
+src_prepare() {
+       if [[ ${PLEVEL} != ${PV} ]] ; then
+               local i
+               for (( i = 1; i <= PLEVEL; ++i )) ; do
+                       eapply "${FILESDIR}"/${MY_PV}/patch$(printf '%02d' ${i})
+               done
+       fi
+       eapply_user
+       find . -type f -exec touch -r configure {} +
+       elibtoolize
+}
+
+multilib_src_configure() {
+       # Make sure mpfr doesn't go probing toolchains it shouldn't #476336#19
+       ECONF_SOURCE=${S} \
+       user_redefine_cc=yes \
+       econf $(use_enable static-libs static)
+}
+
+multilib_src_install_all() {
+       rm "${ED}"/usr/share/doc/"${P}"/COPYING*
+       use static-libs || find "${ED}"/usr -name '*.la' -delete
+}
+
+pkg_preinst() {
+       preserve_old_lib /usr/$(get_libdir)/libmpfr$(get_libname 4)
+}
+
+pkg_postinst() {
+       preserve_old_lib_notify /usr/$(get_libdir)/libmpfr$(get_libname 4)
+}

diff --git a/dev-libs/mpfr/mpfr-4.1.0.ebuild b/dev-libs/mpfr/mpfr-4.1.0.ebuild
new file mode 100644
index 0000000..bb16255
--- /dev/null
+++ b/dev-libs/mpfr/mpfr-4.1.0.ebuild
@@ -0,0 +1,32 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit multilib-minimal
+
+DESCRIPTION="library for multiple-precision floating-point computations with 
exact rounding"
+HOMEPAGE="https://www.mpfr.org/";
+SRC_URI="https://www.mpfr.org/mpfr-${PV}/${P}.tar.xz";
+
+LICENSE="LGPL-2.1"
+SLOT="0/6" # libmpfr.so version
+KEYWORDS="~alpha amd64 arm arm64 hppa ~ia64 ~m68k ~mips ppc ~ppc64 ~riscv s390 
sparc x86 ~ppc-aix ~x64-cygwin ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos 
~x86-macos ~m68k-mint ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+IUSE="static-libs"
+
+RDEPEND=">=dev-libs/gmp-5.0.0[${MULTILIB_USEDEP},static-libs?]"
+DEPEND="${RDEPEND}"
+
+HTML_DOCS=( doc/FAQ.html )
+
+multilib_src_configure() {
+       # Make sure mpfr doesn't go probing toolchains it shouldn't #476336#19
+       ECONF_SOURCE=${S} \
+               user_redefine_cc=yes \
+               econf $(use_enable static-libs static)
+}
+
+multilib_src_install_all() {
+       rm "${ED}"/usr/share/doc/"${P}"/COPYING*
+       use static-libs || find "${ED}"/usr -name '*.la' -delete
+}

Reply via email to